﻿Imports iTextSharp.text.pdf

Public Class Main
    Public Const Debugmode As Boolean = False

#Region "--->Variablen"

    Public oSwApp As SldWorks.SldWorks
    Public swModel As SldWorks.ModelDoc2
    Public swDraw As SldWorks.DrawingDoc

    Public Datei As String
    Public MyPath As String = My.Settings.BrowsePath

#End Region

#Region "--->Browsing + Knöpfe"

    Private Sub Bt_Browse_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Bt_Browse.Click

        Dim FolderBrowserDialog1 As FolderBrowserDialog = New System.Windows.Forms.FolderBrowserDialog

        With FolderBrowserDialog1
            .RootFolder = Environment.SpecialFolder.MyComputer
            .SelectedPath = MyPath
            .ShowNewFolderButton = False
            .Description = "Bitte Pfad auswählen:"
        End With

        If FolderBrowserDialog1.ShowDialog = Windows.Forms.DialogResult.OK Then
            My.Settings.BrowsePath = FolderBrowserDialog1.SelectedPath
            MyPath = FolderBrowserDialog1.SelectedPath

            'Zeichnungen einlesen
            Preview()
        End If

        Lb_Pfad.Text = "Pfad: " + MyPath
    End Sub

    Private Sub Preview()

        Dim files() As String = IO.Directory.GetFiles(MyPath, "*.slddrw")

        Dim sFilename As String
        Dim sDirectory As String
        Dim i As Integer = 0
        Dim c As Integer = 0

        Array.Sort(files)

        For i = 0 To files.Count - 1

            If CStr(files(i)).Contains("~$") = False Then

                'Verzeichnis
                sDirectory = IO.Path.GetDirectoryName(CStr(files(i)))

                'Dateiname
                sFilename = IO.Path.GetFileName(CStr(files(i)))

                If Not AddUnique(DataGridView1, sFilename) Then
                    Me.DataGridView1.Rows.Add(1, sFilename, sDirectory)
                End If

            End If

        Next i

        SimpleStatus("Dateien auswählen und [PDF erzeugen] klicken um fortzufahren.")

    End Sub

    Private Sub Bt_alle_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Bt_alle.Click
        For i = 0 To DataGridView1.RowCount - 1
            DataGridView1.Rows(i).Cells(0).Value = 1
        Next i
    End Sub

    Private Sub Bt_keine_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Bt_keine.Click
        For i = 0 To DataGridView1.RowCount - 1
            DataGridView1.Rows(i).Cells(0).Value = 0
        Next i
    End Sub

    Private Sub Bt_invert_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Bt_invert.Click
        For i = 0 To DataGridView1.RowCount - 1
            DataGridView1.Rows(i).Cells(0).Value = Math.Abs(CInt(DataGridView1.Rows(i).Cells(0).Value)) - 1
        Next i
    End Sub

    Private Sub Bt_Close_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Bt_Close.Click
        Application.Exit()
    End Sub

    Private Sub Bt_loeschen_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Bt_loeschen.Click

        Dim i As Integer = 0

        While DataGridView1.RowCount > 0 And i < DataGridView1.RowCount

            Debug.Print(DataGridView1.Rows(i).Cells(0).Value.ToString)

            If CBool(DataGridView1.Rows(i).Cells(0).Value) = True Then
                DataGridView1.Rows.Remove(DataGridView1.Rows.Item(i))
                i -= 1
            End If

            i += 1
        End While

        DataGridView1.Focus()
    End Sub

    Private Sub Bt_leeren_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Bt_leeren.Click
        DataGridView1.Rows.Clear()
    End Sub

    Private Sub Bt_PDFgen_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Bt_PDFgen.Click

        Dim Response As DialogResult
        'SolidWorksInstanzCreate()
        If SolidWorksBelegen(oSwApp) = False Then
            MessageBox.Show("Bitte starten Sie SolidWorks und führen den Druckvorgang nocheinmal aus.", "SolidWorks nicht gefunden", MessageBoxButtons.OK, MessageBoxIcon.Exclamation)
            Exit Sub
        Else
            If Debugmode Then Debug.Print("SolidWorks läuft schon.")

            swModel = CType(oSwApp.ActiveDoc, SldWorks.ModelDoc2)
            If swModel Is Nothing Then         ' Check to see if a document
                Laden()
            Else
                Response = MessageBox.Show("Es ist mindestens ein Dokument in SolidWorks geöffnet." + Environment.NewLine + "Soll ich alle offenen Dokumente ohne zu speichern schliessen und dann fortfahren?", "Auswahl?", MessageBoxButtons.YesNo, MessageBoxIcon.Error, MessageBoxDefaultButton.Button2)

                If Response = DialogResult.Yes Then    ' User chose Yes.
                    CloseAll()                  ' Close all files
                    Laden()
                Else    ' User chose No.
                    Exit Sub
                End If
            End If

        End If

    End Sub

#End Region

#Region "--->Laden + Konvertieren"

    Sub Laden()
        Dim sFilename As String
        Dim sDirectory As String
        Dim longerrors As Long
        Dim longstatus As Long

        For i As Integer = 0 To DataGridView1.RowCount - 1

            If CBool(DataGridView1.Rows(i).Cells(0).Value) = True Then

                sFilename = DataGridView1.Rows(i).Cells(1).Value.ToString

                sDirectory = DataGridView1.Rows(i).Cells(2).Value.ToString
                Datei = sDirectory + "\" + sFilename

                SimpleStatus(sFilename + " wird geöffnet...")
                oSwApp.OpenDoc6(Datei, swDocDRAWING, swOpenDocOptions_Silent, "", CInt(longerrors), CInt(longstatus))

                SimpleStatus(sFilename + " wird konvertiert...")
                PDFdiz()

                SimpleStatus("Dateieigenschaften werden an PDF übergeben")
                AddCustomInfo()

                SimpleStatus(sFilename + " wird geschlossen...")
                oSwApp.CloseDoc(Datei)

                DataGridView1.Rows(i).Cells(0).Value = 0

            End If
        Next i

        SimpleStatus("Fertig")

    End Sub

    Public Sub PDFdiz()

        Dim saveFileName As String
        Dim nRetVal As Integer
        Dim nErrors As Integer
        Dim nWarnings As Integer
        Dim bRet As Boolean
        Dim Dateigroesse As Long

        Dim ExportEmbedFonts As Boolean
        Dim ExportHighQuality As Boolean
        Dim ExportInColor As Boolean
        Dim ExportPrintHeaderFooter As Boolean
        Dim ExportUseCurrentPrintLineWeights As Boolean

        swModel = CType(oSwApp.ActiveDoc, SldWorks.ModelDoc2)

        saveFileName = IO.Path.GetDirectoryName(Datei) + "\" + IO.Path.GetFileNameWithoutExtension(Datei) + ".pdf"
        If Debugmode = True Then Debug.Print("PDF-Output : " + saveFileName)

        'Optionen speichern
        ExportEmbedFonts = oSwApp.GetUserPreferenceToggle(swPDFExportEmbedFonts)
        ExportHighQuality = oSwApp.GetUserPreferenceToggle(swPDFExportHighQuality)
        ExportInColor = oSwApp.GetUserPreferenceToggle(swPDFExportInColor)
        ExportPrintHeaderFooter = oSwApp.GetUserPreferenceToggle(swPDFExportPrintHeaderFooter)
        ExportUseCurrentPrintLineWeights = oSwApp.GetUserPreferenceToggle(swPDFExportUseCurrentPrintLineWeights)


        ' Setzen der PDF - Einstellung für den Export  
        oSwApp.SetUserPreferenceToggle(swPDFExportEmbedFonts, True)
        oSwApp.SetUserPreferenceToggle(swPDFExportHighQuality, False)
        oSwApp.SetUserPreferenceToggle(swPDFExportInColor, True)
        oSwApp.SetUserPreferenceToggle(swPDFExportPrintHeaderFooter, False)
        oSwApp.SetUserPreferenceToggle(swPDFExportUseCurrentPrintLineWeights, True)

        'Speichern der Files
        bRet = swModel.ForceRebuild3(True)
        bRet = swModel.SaveAs4(saveFileName, swSaveAsCurrentVersion, swSaveAsOptions_Silent, nErrors, nWarnings)

        ' Liefert die Dateilänge in Bytes
        Dateigroesse = New IO.FileInfo(saveFileName).Length

        If Debugmode = True Then Debug.Print(CStr(Dateigroesse))

        'Meldung ob PDF-Speicherung erfolgreich war
        If bRet = False Then
            nRetVal = MessageBox.Show("Probleme beim Speichern der Datei.", "Fehler", MessageBoxButtons.OK, MessageBoxIcon.Warning)
        Else
            If Dateigroesse < 1000 Then
                nRetVal = MessageBox.Show("Die Datei ist kleiner als 1kB. Bitte überprüfen Sie die erstellte Datei.", "Fehler", MessageBoxButtons.OK, MessageBoxIcon.Warning)
            End If
        End If

        'Optionen reset
        oSwApp.SetUserPreferenceToggle(swPDFExportEmbedFonts, ExportEmbedFonts)
        oSwApp.SetUserPreferenceToggle(swPDFExportHighQuality, ExportHighQuality)
        oSwApp.SetUserPreferenceToggle(swPDFExportInColor, ExportInColor)
        oSwApp.SetUserPreferenceToggle(swPDFExportPrintHeaderFooter, ExportPrintHeaderFooter)
        oSwApp.SetUserPreferenceToggle(swPDFExportUseCurrentPrintLineWeights, ExportUseCurrentPrintLineWeights)

    End Sub

    ''' <summary>
    ''' Dokumenteigenschaften ermitteln und in einer Dictionary zurückgeben 
    ''' </summary>
    ''' <remarks>Snippet von MySldWorks.de (Dokumenteigenschaften ermitteln)</remarks>
    Public Function ReadProps() As Dictionary(Of String, String)
        Try
            swModel = CType(oSwApp.ActiveDoc, SldWorks.ModelDoc2)

            'Dictionary für die ermittelten Dokumenteigenschaften und dessen Wert
            Dim scEigenschaftenUndWert As System.Collections.Generic.Dictionary(Of String, String)
            'Stringarray für die vorhandenen Dokumenteigenschaften des Dokuments
            Dim sEigenschaften() As String
            'Inhalt der Dokumenteigenschaft
            Dim sInhalt As String = Nothing
            sEigenschaften = CType(swModel.GetCustomInfoNames2(""), String())
            'Dictionary initialisieren
            scEigenschaftenUndWert = New System.Collections.Generic.Dictionary(Of String, String)
            If sEigenschaften IsNot Nothing Then
                'Alle Eigenschaften berücksichtigen und dessen Wert ermitteln
                For iEigenschaft As Integer = 0 To sEigenschaften.GetUpperBound(0)
                    'Inhalt der Eigenschaft ermitteln
                    sInhalt = swModel.GetCustomInfoValue("", sEigenschaften(iEigenschaft))
                    'Eigenschaften und dessen Wert ermitteln, Wert als Eintrag in die Dictionary
                    scEigenschaftenUndWert.Add(sEigenschaften(iEigenschaft), sInhalt)
                Next
            End If
            Return scEigenschaftenUndWert
        Catch ex As Exception
            Debug.Assert(False)
            Trace.WriteLine("Fehler: Wo: " & ex.StackTrace & " Was: " & ex.Message)
            Throw New Exception(ex.Message, ex)
        End Try
    End Function

    Public Sub AddCustomInfo()

        Dim scCustomPropertys As Dictionary(Of String, String) = ReadProps()

        Dim Filename As String
        Filename = IO.Path.GetDirectoryName(Datei) + "\" + IO.Path.GetFileNameWithoutExtension(Datei) + ".pdf"

        Dim fsR As FileStream = File.OpenRead(Filename)
        Dim reader As PdfReader = New PdfReader(fsR)
        fsR.Close()

        Dim Information As Dictionary(Of String, String) = reader.Info

        For Each sName As String In scCustomPropertys.Keys
            'Debug.Print("Name: " & sName & " Inhalt: " & scCustomPropertys.Item(sName))

            If Information.ContainsKey(sName) Then
                'Remove existing key before re-adding it...
                Information.Remove(sName)
            End If
            Information.Add(sName, scCustomPropertys.Item(sName))
        Next
        'File.Delete(Filename)

        Dim fsW As FileStream = File.Create(Filename) '.Replace(".pdf", "_new.pdf"))
        Dim stamper As PdfStamper = New PdfStamper(reader, fsW)

        stamper.MoreInfo = Information
        stamper.Close()
        reader.Close()
        fsW.Close()

    End Sub

#End Region

#Region "--->Initialisieren, SolidWorks überprüfen"

    Public Sub New()
        ' This call is required by the Windows Form Designer. 
        InitializeComponent()
        ' Add any initialization after the InitializeComponent() call.

        Me.Text = "SolidWorks Zeichnungen Batch-PDF-Konverter"
        Me.Icon = My.Resources.SWX_PDF

        MyPath = My.Settings.BrowsePath

        Lb_Pfad.Text = "Pfad: " + MyPath

        isx64()
        SimpleStatus("Klicken sie [Ordner wechseln] um Zeichnungen hinzuzufügen.")

    End Sub

    ' Displays text in the LabelStatus on the form
    Private Sub SimpleStatus(ByRef Stat As String)
        Lb_Status.Text = " " + Stat
        Me.Refresh()
    End Sub

    Public Function SolidWorksBelegen(ByRef oSwApp As SldWorks.SldWorks) As Boolean
        Try
            'messagebox.show rückgabe
            Dim lDialogStatus As DialogResult
            Try
                'SolidWorks Objekt belegen
                'oSwApp = CType(GetObject(, "SldWorks.Application"), SldWorks.SldWorks)

                oSwApp = CType(System.Runtime.InteropServices.Marshal.GetActiveObject("SldWorks.Application"), SldWorks.SldWorks)

            Catch ex As Exception
                'Fehler beim Belegen des SolidWorks Objekts
                'Evtl. ist SolidWorks nicht geöffnet
            End Try
            'Wenn das SolidWorks Objekt nicht belegt ist...
            If oSwApp Is Nothing Then
                '... in einer messagebox.show nachfragen
                lDialogStatus = MessageBox.Show( _
                   "Fehler beim Aufbau einer Schnittstelle zu SolidWorks." + Environment.NewLine + _
                   "Bitte öffnen Sie SolidWorks und klicken Sie auf ""Ok""." + Environment.NewLine + _
                   "Sollte SolidWorks bereits geöffnet sein, schließen Sie SolidWorks, " + Environment.NewLine + _
                   "öffnen Sie es erneut und klicken Sie dann auf ""Ok""" + Environment.NewLine + _
                   "Wenn Sie denn Startvorgang abbrechen möchten klicken Sie auf ""Abbrechen""", _
                   "Fehler beim Aufbau einer Schnittstelle", MessageBoxButtons.OKCancel, MessageBoxIcon.Information)
                'Rückgabewert prüfen
                Select Case lDialogStatus
                    Case DialogResult.OK
                        'User hat SolidWorks geöffnet
                        'Funktion einfach nochmal aufrufen
                        Return SolidWorksBelegen(oSwApp)
                    Case DialogResult.Cancel
                        'User möchte die Anwednung abbrechen
                        Return False
                End Select
                'SolidWorks anzeigen
                oSwApp.Visible = True
                oSwApp.UserControlBackground = True
            End If
            Return True
        Catch ex As Exception
            Debug.Assert(False)
            Trace.WriteLine("Fehler: Wo: " + ex.StackTrace + " Was: " + ex.Message)
            Return False
        End Try
    End Function

    Public Sub isx64()

        Dim architecture As Integer = Runtime.InteropServices.Marshal.SizeOf(GetType(IntPtr)) * 8
        If architecture = 32 Then
            Me.Text = Me.Text + " (32bit)"
        ElseIf architecture = 64 Then
            Me.Text = Me.Text + " (64bit)"
        End If
    End Sub

    Function CloseAll() As Boolean
        Dim OpenDoc As SldWorks.ModelDoc2

        OpenDoc = CType(oSwApp.ActiveDoc(), SldWorks.ModelDoc2)
        While Not OpenDoc Is Nothing
            oSwApp.QuitDoc(OpenDoc.GetTitle)
            OpenDoc = CType(oSwApp.ActiveDoc(), SldWorks.ModelDoc2)
        End While
        Return Nothing
    End Function

    Private Sub DataGridView1_MouseHover(ByVal sender As Object, ByVal e As System.EventArgs) Handles DataGridView1.MouseHover
        DataGridView1.Focus()
    End Sub

#End Region

#Region "--->Drag + Drop"

    Private Sub DGV1_DragEnter(ByVal sender As Object, ByVal e As System.Windows.Forms.DragEventArgs) Handles DataGridView1.DragEnter
        If e.Data.GetDataPresent(DataFormats.FileDrop) Then
            e.Effect = DragDropEffects.All
        End If
    End Sub

    Private Sub DGV1_DragDrop(ByVal sender As Object, ByVal e As System.Windows.Forms.DragEventArgs) Handles DataGridView1.DragDrop
        Dim sFilename As String
        Dim sDirectory As String
        If e.Data.GetDataPresent(DataFormats.FileDrop) Then
            Dim DroppedFiles As String() = CType(e.Data.GetData(DataFormats.FileDrop), String())
            For i As Int32 = 0 To DroppedFiles.Length - 1
                If IO.Path.GetExtension(DroppedFiles(i)).ToUpper = ".SLDPRT" Or IO.Path.GetExtension(DroppedFiles(i)).ToUpper = ".SLDASM" Then
                    If DroppedFiles(i).Contains("~$") = False Then
                        'Verzeichnis
                        sDirectory = IO.Path.GetDirectoryName(DroppedFiles(i))
                        'Dateiname
                        sFilename = IO.Path.GetFileName(DroppedFiles(i))

                        If Not AddUnique(DataGridView1, sFilename) Then
                            Me.DataGridView1.Rows.Add(1, sFilename, sDirectory)
                        End If

                    End If
                End If
            Next
            SimpleStatus("Dateien auswählen und [Drucken] klicken um fortzufahren.")
        End If
    End Sub

    Private Function AddUnique(ByVal cbo As DataGridView, ByVal newitem As String) As Boolean
        Dim i As Integer
        For i = 0 To cbo.RowCount - 1
            If DataGridView1.Rows(i).Cells(1).Value.ToString = newitem Then
                Return True
                Exit For
            End If
        Next
        Return False
    End Function

#End Region

End Class
